#ifndef CLIENT_H
#define CLIENT_H
#include <string>
#include <vector>
#include "engine/util_vector.h"
#include "timehandling.h"

#undef NDEBUG
#include <assert.h>

#include "engine/wrect.h"
#include "engine/cl_dll.h"

#include "cvar.h"

class Vector3df
{
public:
	float x,y,z;
};

class VertexAlign
{
public:
	Vector3df close;
	Vector3df farfrom;
//	Vector3d downleft;
//	Vector3d downright;
};

class Vector2df
{
public:
	float x,y;
};

class Vector3dd
{
public:
	double x,y,z;
};

class _players
{
public:
	enum TEAM { CT=0, TERR, HOSTAGE, UNKNOWN };
	bool alive;
	float height;
	float distance[1];
	long vertices;
	int totalplayers;
	TEAM team;
//	VertexAlign verts;
	Vector3df lowestpointz;
	Vector3df highestpointz;
	Vector3df targetpos;
	Vector2df screenpos;
	Vector3dd newtop;		// Converted XYZ from highestpointz-gluproject-newtop
	Vector3dd newbottum;	// Converted XYZ from lowestpointz-gluproject-newbottum
	Vector3df wtop;			// Gone threw gluproject-screenpos
	Vector3df wbottum;		// Gone threw gluproject-screenpos
};

class _bot
{
public:
	_players players[32];
	int current;
	int size;
	bool active;
};
extern _bot bot;

class _ogl
{
public:
	double mm[16],pm[16];

	int tempy;

	//double wx,wy,wz;			// Stored in bot.players(new.)
	//double wx2,wy2,wz2;		// Stored in bot.players(new.)
	float color[4], position[4];
};

std::string getOgcDirFile(const char* basename);
extern char ogcdir [256];
extern char hldir  [256];

extern cl_enginefuncs_s *pEngfuncs;

void tintArea(int x,int y,int w,int h, struct ColorEntry* clr);
void gDrawFilledBoxAtLocation( float* origin, DWORD color = 0xFFFFFFFF, int radius=1);
void gSetHudMessage2(const char* message);
void gSetHudMessage(const char* message);
void Con_Echo(const char *fmt, ... );

// from cldll_int.h 
#ifndef CDLL_INT_H
typedef unsigned char 		byte;
typedef unsigned short 		word;
typedef struct
{
	char *name;
	short ping;
	byte thisplayer;  // TRUE if this is the calling player

  // stuff that's unused at the moment,  but should be done
	byte spectator;
	byte packetloss;

	char *model;
	short topcolor;
	short bottomcolor;

} hud_player_info_t;
#endif

//================================================================
struct local_player_info
{
	local_player_info():team(0),iClip(0),iFOV(0)
		,inZoomMode(false)
		,alive(false),headshots(0),entindex(0)
	{}

	int team;
	//struct cl_entity_s *ent;
	int iClip;
	int iFOV;  // holds the current FOV in CS, not the one which OGC has set.
	bool inZoomMode;
	bool alive;
	float punchangle[3];
	int pmFlags; 
	int pmMoveType; // movetype 5 = ladder
	float pmVelocity[3];
	float pmEyePos[3];

	float viewAngles[3];

	int entindex;
	//int kills;  // already found in playerinfo
	//int deaths; // already found in playerinfo
	int headshots;
	float hspercent;
};
extern local_player_info me;



//================================================================
enum    { MAX_TARGET_SPOTS=10 };
class PlayerInfo 
{
protected:
	friend class VecPlayers;
	void init( int _entindex) 
	{ 
		team=2;
		iInfo=0;
		entinfo.name="\\missing-name\\";
		entinfo.ping=0;
		entinfo.thisplayer=0;
		entinfo.spectator=0;
		entinfo.packetloss=0;
		entinfo.model="missing-model";
		entinfo.topcolor=0;
		numTargetSpots=0;
		alive=false;
		entindex = _entindex;
		distance = 1000.0;
		visible  = false;
		frags=0;
		deaths=0;
		ratio=0;
		bestplayer=false;
		m_lastUpdateType=0;
		strcpy(m_weapon,"N-A");
	}
private:
	hud_player_info_t entinfo;

public:
	void updateEntInfo();
	const char* getName() const { return entinfo.name; }

	int    team;
	int    iInfo;
	float  distance;
	bool   visible;

	// infos needed for points system:
	int    frags;
	int    deaths;
	float  ratio;
	bool   bestplayer; // based on ratio, not frags!
	float  fovangle;   // minimum fov a player is in

	// aimbot points
	float points;

	// model based aiming data:
	int     numTargetSpots;
	vec3_t  TargetSpots[MAX_TARGET_SPOTS];

	void setAlive() { alive = true;  }
	void setDead () { alive = false; m_lastUpdateType=UPDATE_MISSING; }
	bool isAlive () { return  alive; }

	struct cl_entity_s * getEnt() { return oEngfuncs.GetEntityByIndex(entindex); }

	// position update reporting
	void   updateClear()
	{ 
		m_lastUpdateType=UPDATE_MISSING; 
	}
	
	void   updateAddEntity (const float* neworg)
	{ 
		if(alive)
		{
			m_lastUpdateType=UPDATE_ADDENT; 
			m_lastUpdateTime=ClientTime::current; 
			VectorCopy(neworg,m_origin);
			if(timeSinceLastUpdate()>0.3)
				m_lastUpdateType=UPDATE_MISSING;
		}
	}
	
	void   updateSoundRadar(const float* neworg)   
	{ 
		if(alive)
		{
			if( m_lastUpdateType!=UPDATE_ADDENT || timeSinceLastUpdate()>0.3 ) // dont mess with hud_addentity updates
			{
				m_lastUpdateType=UPDATE_SOUND_RADAR;  
				m_lastUpdateTime=ClientTime::current; 
				VectorCopy(neworg,m_origin); 
			}
		}
	}

	// position update queries
	enum	{ UPDATE_MISSING=0, UPDATE_ADDENT=1, UPDATE_SOUND_RADAR=2};
	bool	isUpdated       ()		{ return m_lastUpdateType!=UPDATE_MISSING; }
	bool	isUpdatedAddEnt ()		{ return m_lastUpdateType==UPDATE_ADDENT;  }
	int		updateType()			{ return m_lastUpdateType; }
	float	*origin()				{ return m_origin; }
	float	timeSinceLastUpdate()	{ return (float)(ClientTime::current-m_lastUpdateTime); }
	

	// weapon update:
	const char* getWeapon() { return m_weapon; }
	void setWeapon(const char* newname)
	{
		register int len = strlen(newname);
		if(len && len<30) { strcpy(m_weapon,newname); }
	}


private:
	int     m_lastUpdateType;
	double  m_lastUpdateTime;
	float   m_origin[3];
	char    m_weapon[32];

	bool alive;
	int entindex;

public:
	PlayerInfo() { init(0); }
};

//================================================================
enum{  MAX_VPLAYERS = 36 };
class VecPlayers
{
private:
	PlayerInfo* players;
public:
	~VecPlayers() { delete[] players; }
	VecPlayers() 
	{ 
		players = new PlayerInfo[MAX_VPLAYERS];
		for(int i=0;i<MAX_VPLAYERS;i++) { players[i].init(i); }
	}

	inline PlayerInfo& operator [] (unsigned int i)
	{
		if(i>=MAX_VPLAYERS) {return players[0];}
		else                {return players[i];}
	}
	
	inline unsigned int size() { return MAX_VPLAYERS; }
};
extern VecPlayers vPlayers;

#endif