#ifndef MAIN_H
#define MAIN_H

// WGL Function Typedefs
typedef void(APIENTRY *func_wglSwapBuffers)( HDC );
extern func_wglSwapBuffers org_wglSwapBuffers;

// GL Function Typedefs
typedef void (APIENTRY *glv) (void);
typedef void (APIENTRY *glfv) (const GLfloat*);
typedef void (APIENTRY *gli) (unsigned int);
typedef void (APIENTRY *glview) ( int,int,GLsizei,GLsizei );
typedef void (APIENTRY *gl2f)( float , float );
typedef void (APIENTRY *gl3f)( float , float , float );
typedef void (APIENTRY *gl4f)( float , float , float , float );
typedef void (APIENTRY *gl2i) (int, int);
typedef void (APIENTRY *gl2ui) (unsigned int, unsigned int);
typedef void (APIENTRY *glTexEnv) (unsigned int, unsigned int, int);
typedef void (APIENTRY *glif) (unsigned int,float*);
typedef void (APIENTRY *gl4f) (GLfloat, GLfloat, GLfloat, GLfloat);
typedef void (APIENTRY *gl4ub) (byte,byte,byte,byte);
typedef void (APIENTRY *gl3ub) (byte,byte,byte);
typedef void (APIENTRY *glBlendFunct) (GLenum sfactor, GLenum dfactor);
typedef void (APIENTRY *glColor4fFunct) (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
typedef void (APIENTRY *glLineWidthFunct) (GLfloat width);
typedef void (APIENTRY *glRectiFunct) (GLint x, GLint y, GLint x2, GLint y2);
typedef void (APIENTRY *glFrustumFunct) (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
typedef void (APIENTRY *glCallFunct) (GLsizei,unsigned,const GLvoid*);
typedef void (APIENTRY *glwglSwapBuffersFunct) (HDC);
typedef void (APIENTRY *glGetBoolFunct) (unsigned,GLboolean*);
typedef void (APIENTRY *glGetDFunct) (unsigned,GLdouble*);
typedef void (APIENTRY *glGetIFunct) (unsigned,GLint*);
typedef void (APIENTRY *glDrawPFunct) (GLsizei,GLsizei,unsigned,unsigned,const GLvoid*);

class _orig
{
public:
	gli				glBegin;
	gli				glDisable;
	gli				glEnable;
	gli				glShadeModel;
	gl3f			glColor3f;
	gl2f			glVertex2f;
	gl3f			glVertex3f;
	glv				glPopMatrix;
	gl2f			glTexCoord2f;
	glfv			glVertex3fv;
	glview			glViewport;
//	glTexEnv		glTexEnvi;
//	gl2ui			glPolygonMode;
//	gl4f			glClearColor;
	gli				glClear;
	glif			glGetFloatv;
	glColor4fFunct	glColor4f;
	glBlendFunct	glBlendFunc;
	glLineWidthFunct	glLineWidth;
//	glRectiFunc		glRecti;
//	glFrustumFunc	glFrustum;
	glwglSwapBuffersFunct wglSwapBuffers;

	glfv			glColor4fv;
	glv				glEnd;
	glv				glPushMatrix;
	glv				glLoadIdentity;
	gl3ub			glColor3ub;
	gl4ub			glColor4ub;
	gl2i			glVertex2i;
	glGetBoolFunct	glGetBooleanv;
	gli				glPushAttrib;
	gli				glListBase;
	gl2i			glRasterPos2i;
	glv				glPopAttrib;
	glCallFunct		glCallLists;
	gl2f			glRasterPos2f;
	gl3f			glRasterPos3f;
	glfv			glRasterPos3fv;
	glDrawPFunct	glDrawPixels;
	gli				glDepthFunc;
	glGetDFunct		glGetDoublev;
	gli				glMatrixMode;
	glGetIFunct		glGetIntegerv;
	gl2i			glPixelStorei;
};
extern _orig orig;

void	gl_initialize();

void	gl_patch();
void	gl_restore();

typedef struct
{
	DWORD*addr;
	DWORD new_function;
	DWORD old_function;
} patcher_x4_t;

void	mem_patch_x4		(patcher_x4_t *patcher);
void	mem_restore_x4		(patcher_x4_t *patcher);

#endif //OPENGLHOOK_H